#!ruby -Ks
#exerbŌł߂exeNƂJgfBNgexẽpXɂ
if defined?(ExerbRuntime)
  Dir.chdir(File.dirname(ExerbRuntime.filepath))
end
######################################################
require 'dxruby'
require 'lib/scene.rb'
require 'lib/button.rb'
require 'lib/font.rb'
require 'lib/image.rb'
######################################################
Black  = [0, 0, 0,]
White  = [255, 255, 255]
Green  = [0, 255, 0]
Blue   = [0, 0, 255]
Red    = [255, 0, 0]
Orange = [255, 255, 0]
Gray   = [220, 220, 220]
Dgray  = [120, 120, 120]
Yellow = [225,225,0]
Purple = [164,73,164]
Clear  = [0, 0, 0, 0]
######################################################
Window_w = 1024
Window_h = 768
Window.width  = Window_w
Window.height = Window_h
Window.bgcolor = Gray
Window.x = 80
Window.y = 0
Window.windowed = false
#Window.scale = 1.5
Window.caption = "canvas" 
#Window.fps = 10
Window.frameskip = true
Window.loadIcon("./lib/easel_16.ico")
######################################################
#֐ݒ
def load_datafile(filename)
  array = []
  open(filename) do |file|
    while l = file.gets
       array.push l.chomp.split(",")
    end
  end
  return array
end
$option  = Array.new
$option  = load_datafile("./lib/option.txt")
#ݒ
$option2  = Array.new
$option2  = load_datafile("./lib/config2.txt")
$serect = $option2[0][0].to_i #0Œ掦ʂ
$next_serect = $option2[0][1].to_i#0Ń{^
####################################################################################################
#logfBNgȂ΍쐬
if FileTest.exist?("shot") == false
  Dir::mkdir("shot")
end
if  FileTest.exist?("shot/#{Time.now.strftime("%Y_%m_%d")}") == false
  Dir::mkdir("shot/#{Time.now.strftime("%Y_%m_%d")}")
  Dir::mkdir("shot/#{Time.now.strftime("%Y_%m_%d")}/00")
  file = File::open("lib/log_ini.txt", "w")
  file.puts 0
  file.close
else
  array = []
  open("lib/log_ini.txt") do |file|
    while l = file.gets
      array.push l.chomp.split(',')
    end
  end
  count= array[0][0].to_i+1
  file = File::open("lib/log_ini.txt", "w")
  file.puts "#{count}"
  file.close
  if count < 10
    Dir::mkdir("shot/#{Time.now.strftime("%Y_%m_%d")}/0#{count}")
  else
    Dir::mkdir("shot/#{Time.now.strftime("%Y_%m_%d")}/#{count}")
  end
end
######################################################
#logfBNgȂ΍쐬
if FileTest.exist?("log") == false
  Dir::mkdir("log")
end
######log########################################
def logfile_open(string)
  date = Time.now.strftime("%Y.%m.%d_%H.%M.%S")
  fname = "log/#{string}_#{date}.csv"
  $file = File::open(fname, "w")
end
#######################################################
#######################################################
class S_Timer
  def self.reset  #Ԃ
    @start_time = Time.now
  end

  def self.get  #oߎԂ𓾂
    return Time.now - @start_time
  end 
end
########################################################
class Title_Scene < Scene::Base
  def init
    @btn_start = Button.new(Window_w/2-72, Window_h/2+200, "Jn",36,144,72)
    @btn_esc = Button.new(Window_w-72-5, 0, "I", 16,72,36)
    @btn_option = Button.new(5, 0, "ݒ" , 16,72,36)
    @title = Images.new( Window_w/2 - 240, Window_h/2 - 350)
    @title.image=("./lib/easel_logo.png")
    @title_img = Images.new( Window_w/2 - 150, Window_h/2 - 150)
    @title_img.image=("./lib/easel.png")
    @txt = Fonts.new("[h", Window_w/2 + 200, Window_h/2 - 170,30)
    @op_txt1 = Fonts.new("C : LoX          ",700,600,20)
    @op_txt2 = Fonts.new("N : 摜ۑA̖",700,650,20)
    @copyright1 = Fonts.new("Powerd by DXRuby.",0,700,20,Black)
    @copyright2 = Fonts.new("Copyright (c) 2016 Shimane University Maglab. All Rights Reserved.",0,730,20,Black)
    @copyright1.x = Window_w - 12*(@copyright1.string).size
    @copyright2.x = Window_w - 10*(@copyright2.string).size
    $count=0
    $log_array = Array.new(100).map{Array.new()}
    logfile_open("canvas") 
  end

  def update
    if @btn_start.pushed?
      self.next_scene = Game_Scene
    elsif @btn_esc.pushed?
      exit
    end
    if @btn_option.pushed?
      self.next_scene = Option_Scene
    end
  end

  def render
    @btn_start.render
    @btn_esc.render
    @title.render
    @title_img.render
    @txt.render
    @copyright1.render
    @copyright2.render
    @btn_option.render
    
  end
end

class Option_Scene < Scene::Base
  def init
    @btn_back = Button.new(5, 0, "߂", 16,72,36)
    @txt0     = Fonts.new("ݒ",Window_w/2-140,Window_h/2-360, 70)
    @txt1     = Fonts.new("E񎦉",Window_w/2-450,Window_h/2-260+100, 50)
    @txt2     = Fonts.new("Euցv{^",Window_w/2-450,Window_h/2, 50)
    @btn_serect1 = Button.new(Window_w/2+40, Window_h/2-260+100, "ON",30,100,50)
    @btn_serect2 = Button.new(Window_w/2+200, Window_h/2-260+100, "OFF",30,100,50)
    @btn_next1= Button.new(Window_w/2+40, Window_h/2, "ON",30,100,50)
    @btn_next2= Button.new(Window_w/2+200, Window_h/2, "OFF",30,100,50)
    waku
  end
  def waku
    if $serect == 1
      @waku1 = Images.new( Window_w/2+200, Window_h/2-160)
      @waku1.image=("./lib/waku3.png")
    else
      @waku1 = Images.new( Window_w/2+40, Window_h/2-160)
      @waku1.image=("./lib/waku3.png")
    end
    if $next_serect == 0
      @waku2 = Images.new(Window_w/2+200, Window_h/2)
      @waku2.image=("./lib/waku3.png")
    else
      @waku2 = Images.new( Window_w/2+40, Window_h/2)
      @waku2.image=("./lib/waku3.png")
    end
  end
  
  def write
    #############config2ɏޏ###################
    file = File::open("lib/config2.txt", "w")
    file.puts "#{$serect},#{$next_serect}"
    file.close
    ###########################################
  end
  
  def update
    if @btn_back.pushed?
      write
      self.next_scene = Title_Scene
    end
    if @btn_serect1.pushed?
      $serect = 0
      write
      waku
    end
    if @btn_serect2.pushed?
      $serect = 1
      write
      waku
    end
    if @btn_next1.pushed?
      $next_serect = 1
      write
      waku
    end
    if @btn_next2.pushed?
      $next_serect = 0
      write
      waku
    end
  end
  def render
    @btn_back.render
    @txt0.render
    @txt1.render
    @txt2.render
    @btn_serect1.render
    @btn_serect2.render
    @btn_next1.render
    @btn_next2.render
    @waku1.render
    @waku2.render
  end
end
class Game_Scene < Scene::Base
  def init
    @btn_esc = Button.new(Window_w-72, 0, "I", 16,72,32)
    @btn_next=Button.new(Window_w-100, 700,"", 16,72,32,Dgray)
    @save_count = 0
    @stop = 0
    @pushFlag = 0
    if $serect == 0
      @f_cnv = 0##LoX\ptO
    elsif $serect == 1
      @f_cnv = 1##LoX\ptO
    end
    @log_flag = 0#{^ǂ̔
    canvas_make
    @file_count=load_datafile("lib/log_ini.txt")
    @file_count=@file_count[0][0]
    if  FileTest.exist?("shot/#{Time.now.strftime("%Y_%m_%d")}/#{@file_count}/#{$count}") == false
      if @file_count.to_i < 10
        if $count < 10
          Dir::mkdir("shot/#{Time.now.strftime("%Y_%m_%d")}/0#{@file_count}/0#{$count}")
        else
          Dir::mkdir("shot/#{Time.now.strftime("%Y_%m_%d")}/0#{@file_count}/#{$count}")
        end
      else
        if $count < 10
          Dir::mkdir("shot/#{Time.now.strftime("%Y_%m_%d")}/#{@file_count}/0#{$count}")
        else
          Dir::mkdir("shot/#{Time.now.strftime("%Y_%m_%d")}/#{@file_count}/#{$count}")
        end
      end
    end
    @mouse_before = []
    @mouse_after  = []
    if $option[2][1].to_i == 1
      @btn_pen=Button.new(Window_w-100, 300,"", 16,72,32,Blue)
      @btn_kesi=Button.new(Window_w-100, 400,"", 16,72,32,Dgray)
      @btn_pen.image=("./lib/y.png")
      @btn_kesi.image=("./lib/.png")
      @waku = Button.new(Window_w-100, 300,"", 16,72,32,Blue)
      @waku.image=("./lib/kaku.png")
      @btn_deci=Button.new(Window_w-100, 500,"", 16,72,32,Dgray)
    else
      #pbg
      #pbg̔zF
      @pallet_color = [Black,White,Green,Blue,Red,Orange,Purple,Dgray]
      #pbg̐
      @pallet_image = Array.new
      for i in 0..@pallet_color.size-1
        @pallet_image[i] = Image.new( 50, 50, @pallet_color[i] )
      end
      @pallet_x = 770
      @pallet_y = 150
      #y̏ݒ
      @pen_size  = 1
      @pen_color = Black
      @pen_flag  = :off
      
      #݂̃y̑
      @pen_size_image   = Image.new( 100, 100, Clear )
      @pen_size_image_x = 770
      @pen_size_image_y = 350
      @pen_size_image.circleFill( @pen_size_image.width/2, @pen_size_image.height/2, @pen_size, Black )
      
      #XC_[̐
      @slider   = Image.new( 200, 50, Clear )
      @slider_x = 770
      @slider_y = 450
      @slider.line( 0, 25, 200, 25, Black )
      @slider_point = Image.new( 50, 50, Clear )
      @slider_point.circleFill( 25, 25, 20, White)
      @slider_point_x = 770-25
      @slider_point_y = 450
      #{^
      @btn_deci=Button.new(Window_w-100, 600,"", 16,72,32,Dgray)
      @btn_next=Button.new(Window_w-100, 700,"", 16,72,32,Dgray)
    end
    $pen_color=Black
    $pen_size=5
    $log_stroke = Array.new
    $log_color  = Array.new
    S_Timer.reset
    $log_array[$count].push($count+1)
    #p $log_array
  end

  def load_datafile(filename)
    array = []
    open(filename) do |file|
      while l = file.gets
        array.push l.chomp.split(',')
      end
    end
    return array
  end

  def canvas_make
    @math_canvas = Images.new(20,30,White,$option[3][1].to_i,$option[3][2].to_i,1)
    @canvas_x = 20
    @canvas_y = 30
  end

  def image_save
      @save_count+=1
      if @file_count.to_i < 10
        if $count < 10
          name="shot/"+"#{Time.now.strftime("%Y_%m_%d")}/"+"0#{@file_count}/"+"0#{$count}/"+"#{@save_count}"+".png"
        else
          name="shot/"+"#{Time.now.strftime("%Y_%m_%d")}/"+"0#{@file_count}/"+"#{$count}/"+"#{@save_count}"+".png"
        end
      else
        if $count < 10
          name="shot/"+"#{Time.now.strftime("%Y_%m_%d")}/"+"#{@file_count}/"+"0#{$count}/"+"#{@save_count}"+".png"
        else
          name="shot/"+"#{Time.now.strftime("%Y_%m_%d")}/"+"#{@file_count}/"+"#{$count}/"+"#{@save_count}"+".png"
        end
      end
      @math_canvas.save="#{name}"
  end
  
  def log_save
    if @file_count.to_i < 10
      if $count < 10
        name="shot/"+"#{Time.now.strftime("%Y_%m_%d")}/"+"0#{@file_count}/"+"0#{$count}/"+"#{Time.now.strftime("%Y_%m_%d_%H_%M_%S")}"+".csv"
      else
        name="shot/"+"#{Time.now.strftime("%Y_%m_%d")}/"+"0#{@file_count}/"+"#{$count}/"+"#{Time.now.strftime("%Y_%m_%d_%H_%M_%S")}"+".csv"
      end
    else
      if $count < 10
        name="shot/"+"#{Time.now.strftime("%Y_%m_%d")}/"+"#{@file_count}/"+"0#{$count}/"+"#{Time.now.strftime("%Y_%m_%d_%H_%M_%S")}"+".csv"
      else
        name="shot/"+"#{Time.now.strftime("%Y_%m_%d")}/"+"#{@file_count}/"+"#{$count}/"+"#{Time.now.strftime("%Y_%m_%d_%H_%M_%S")}"+".csv"
      end
    end
    file = File::open("#{name}", "w")
    log=@math_canvas.log
    for i in 0..log.size-1
      for j in 0..log[i].size-1
        if j!=log[i].size-1
          file.printf "#{log[i][j]},"
        else
          file.printf"#{log[i][j]}\n" 
        end
      end
    end
    file.close
  end
  
  def log_csv
    if $serect == 0
      if $log_array[$count].size > 2
        $log_array[$count].push($log_stroke.last)
        $log_array[$count].push(S_Timer.get-$log_array[$count][1]) if @f_cnv == 1
        $file.puts "f[^_#{$log_array[$count][0]},,F,nߎ[s],I莞[s],"
        for i in 0 .. ($log_array[$count].size-3)/2-1
          if $log_color[i] == [0,0,0]
            $file.print ",#{i+1}ڃXg[N,҂,#{$log_array[$count][i*2+2]-$log_array[$count][1]},#{$log_array[$count][i*2+3]-$log_array[$count][1]}"
          else
            $file.print ",#{i+1}ڃXg[N,,#{$log_array[$count][i*2+2]-$log_array[$count][1]},#{$log_array[$count][i*2+3]-$log_array[$count][1]}"
          end
          $file.puts ""#s
        end
        $file.puts ""#s
      end
    elsif $serect == 1
      if $log_array[$count].size > 2
        $log_array[$count].push($log_stroke.last)
        $log_array[$count].push(S_Timer.get-$log_array[$count][1]) if @f_cnv == 1
        $file.puts "f[^_#{$log_array[$count][0]},,F,nߎ[s],I莞[s],"
        for i in 0 .. ($log_array[$count].size-2)/2-1
          #$file.puts ""#s
          if $log_color[i] == [0,0,0]
            $file.print ",#{i+1}ڃXg[N,҂,#{$log_array[$count][i*2+1]},#{$log_array[$count][i*2+2]}"
          else
            $file.print ",#{i+1}ڃXg[N,,#{$log_array[$count][i*2+1]},#{$log_array[$count][i*2+2]}"
          end
          $file.puts ""#s
        end
        $file.puts ""#s
      end
    end
  end
  
  def update
    if @btn_deci.pushed?
      @log_flag = 1
      log_csv
    end
    if @btn_esc.pushed?
      if @f_cnv == 1
        if @log_flag != 1 #ĂȂlog
          log_csv
        end
        image_save
        log_save
      end
      exit
    end
    if @btn_next.pushed? && $next_serect == 1
      if @f_cnv == 0
        @f_cnv=1
        $log_array[$count].push(S_Timer.get)
        I_Timer.reset
      else
        if @log_flag != 1 #ĂȂlog
          log_csv
        end
        image_save
        log_save
        $count += 1
        self.next_scene=Game_Scene
      end
    end
    if Input.keyPush?(K_ESCAPE)
      if @f_cnv == 1
        if @log_flag != 1 #ĂȂlog
          log_csv
        end
        image_save
        log_save
      end
      exit
    end
    @mouse_x = Input.mousePosX
    @mouse_y = Input.mousePosY
    if @f_cnv==1
      #`
      @math_canvas.pen_active($pen_color,$pen_size) #if  @stop%2==0  
      if @mouse_x < 920
        if Input.mousePush?(M_LBUTTON)
          $log_array[$count].push($log_stroke.first)
          @pushFlag = 1
        end
      end
    end
    if  Input.keyPush?(K_C)
      if @f_cnv==0
        @f_cnv=1
        $log_array[$count].push(S_Timer.get)
        I_Timer.reset
      end
    end
    if  Input.keyPush?(K_N)
      if @log_flag != 1 #ĂȂlog
        log_csv
      end
      image_save
      log_save
      $count+=1
      self.next_scene=Game_Scene
    end
    if $option[2][1].to_i == 1
      if @btn_pen.pushed?
        #@btn_pen.color(Blue)
        #@btn_kesi.color(Dgray)
        @waku.y = 300
        $pen_color=Black
        $pen_size=5
      elsif @btn_kesi.pushed?
        #@btn_pen.color(Dgray)
        #@btn_kesi.color(Blue)
        @waku.y = 400
        $pen_color=White
        $pen_size=10
      end
    else#pbg
    #F̕ύX
    if Input.mousePush?( M_LBUTTON )
      for i in 0..@pallet_image.size-1
        if Input.mousePosX >= @pallet_x + 50*(i%4) and Input.mousePosX < @pallet_x + 50*(i%4) + 50
          if Input.mousePosY >= @pallet_y + 50*(i/4) and Input.mousePosY < @pallet_y + 50*(i/4) + 50
            @pen_color = @pallet_color[i]
            @pen_size_image.circleFill( @pen_size_image.width/2, @pen_size_image.height/2, @pen_size, @pen_color )
          end
        end
      end
    end
    #̑ς鏈
    if Input.mouseDown?( M_LBUTTON )
      if @slider_point_x >= @slider_x - @slider_point.width/2 and @slider_point_x <= @slider_x + @slider.width - @slider_point.width/2
        if Input.mousePosX >= @slider_point_x and Input.mousePosX <= @slider_point_x + 40
          if Input.mousePosY >= @slider_point_y and Input.mousePosY <= @slider_point_y + 40
            @slider_point_x = Input.mousePosX - @slider_point.width/2
            @pen_size = (@slider_point_x+@slider_point.width/2 - @slider_x)/5
            @pen_size_image   = Image.new( 100, 100, Clear )
            @pen_size_image.circleFill( @pen_size_image.width/2, @pen_size_image.height/2, @pen_size, @pen_color )
          end
        end
      end
    elsif @slider_point_x < @slider_x - @slider_point.width/2
      @slider_point_x = @slider_x - @slider_point.width/2
      @pen_size = 1
      @pen_size_image   = Image.new( 100, 100, Clear )
      @pen_size_image.circleFill( @pen_size_image.width/2, @pen_size_image.height/2, @pen_size, @pen_color )
    elsif @slider_point_x > @slider_x + @slider.width - @slider_point.width/2
      @slider_point_x = @slider_x + @slider.width - @slider_point.width/2
      @pen_size = 45
      @pen_size_image   = Image.new( 100, 100, Clear )
      @pen_size_image.circleFill( @pen_size_image.width/2, @pen_size_image.height/2, @pen_size, @pen_color )
    end
    end
  end

  def render
    @math_canvas.render if @f_cnv==1
    @btn_esc.render
    @btn_next.render if $next_serect == 1
    if $option[2][1].to_i == 1
      if @f_cnv == 1
        @btn_kesi.render
        @btn_pen.render
        @waku.render
      end
    else#pbg
      #XC_[̕`
      if @f_cnv == 1
        Window.draw( @slider_x, @slider_y, @slider )
        Window.draw( @slider_point_x, @slider_point_y, @slider_point )
        Window.draw( @pen_size_image_x, @pen_size_image_y, @pen_size_image )
        #pbg̕`
        for i in 0..@pallet_color.size-1
          Window.draw( @pallet_x + 50*(i%4), @pallet_y + 50*(i/4), @pallet_image[i] )
        end
      end
    end
    if @f_cnv == 1
      @btn_deci.render
    end
  end
end
########################################################
Scene.main_loop Title_Scene
