#!ruby -Ks
#exerbŌł߂exeNƂJgfBNgexẽpXɂ
if defined?(ExerbRuntime)
  Dir.chdir(File.dirname(ExerbRuntime.filepath))
end
######################################################
require 'dxruby'
require 'lib/scene.rb'
require 'lib/button.rb'
require 'lib/font.rb'
require 'lib/image.rb'
require 'lib/color.rb'
######################################################
Window_w = 1024
Window_h = 768
Window.width  = Window_w
Window.height = Window_h
Window.bgcolor = Cream#White
Window.x = 0
Window.y = 0
Window.windowed = false
Title="OĐ\tg"
#Window.scale = 1.5
Window.caption = "#{Title}" 
Window.fps = 60
Window.frameskip = true
Window.loadIcon("./lib/easel_16.ico")
$sound = Sound.new("sound/push13.wav")    #vbV@Ȃ݂Ɏn߂ɉǂݍނƂɂ͏d
####################################################### logtH_ɂCSVt@C̖OSēǂݍ
$name_day=Dir.glob("shot/*")
#######################################################
$config=Array.new
open("lib/config.txt") do |file|
  while l = file.gets
    $config.push l.chomp.split(",")
  end
end
class S_Timer
  def self.reset  #Ԃ
    @start_time = Time.now
  end

  def self.get  #oߎԂ𓾂
    return Time.now - @start_time
  end 
end
######################################################
class Title_Scene < Scene::Base
  def init
    @btn_full = Button.new(Window_w-72*2, 0, "full/win", 16,72,36)
    @btn_esc = Button.new(Window_w-72, 0, "I", 16,72,36)
    @btn_start = Button.new(Window_w/2-72, Window_h/2+200, "Jn",36,144,72)
    @title = Images.new( Window_w/2 - 240, Window_h/2 - 350)
    @title.image=("./lib/easel_logo.png")
    @title_img = Images.new( Window_w/2 - 150, Window_h/2 - 150)
    @title_img.image=("./lib/easel.png")
    @txt = Fonts.new("logĐ[h", Window_w/2 + 200, Window_h/2 - 170,30)
    @copyright1 = Fonts.new("Powerd by DXRuby.",0,700,20,Black)
    @copyright2 = Fonts.new("Copyright (c) 2016 Shimane University Maglab. All Rights Reserved.",0,730,20,Black)
    @copyright1.x = Window_w - 12*(@copyright1.string).size
    @copyright2.x = Window_w - 10*(@copyright2.string).size
    $count=0
    $day_count_flag = 0#ڂI񂾂^c
  end
  
  def update
    if @btn_full.pushed?
      if Window.windowed?
        Window.windowed = false
      else
        Window.windowed = true
      end
    elsif @btn_esc.pushed?
      exit
    end
    self.next_scene = Day_serect_Scene  if @btn_start.pushed?
  end

  def render
    @btn_full.render
    @btn_esc.render
    @btn_start.render
    @title.render
    @title_img.render
    @txt.render
    @copyright1.render
    @copyright2.render
  end
end
class Day_serect_Scene < Scene::Base
  def init
    @btn_name = Array.new
    @btn_esc = Button.new(Window_w-72, 0, "I", 16,72,36)
    for i in 0 .. $name_day.size-1
      @btn_name[i] = $name_day[i].dup
      for j in 0 .. 4#shot/폜
        @btn_name[i].slice!(0)
      end
    end
    @page = 0
    @page_num = 0
    @btn_up   = Button.new(Window_w/2+200,Window_h/2 - 25  , "", 16,50,50)
    @btn_down = Button.new(Window_w/2-250,Window_h/2 - 25  , "", 16,50,50)
    @btn_day = Array.new
    for i in 0 .. $name_day.size-1
      @btn_day[i] = Button.new(Window_w/2-72*2,Window_h/2 - 200 + 40*(i%10) , "#{@btn_name[i]}", 16,72*4,36)
      @page = i/10
    end
    $day_count_flag = 0
    $back_flag = 0
  end
  
  def update
    if @page > @page_num
      for i in 0 .. 9
        if @btn_day[i + @page_num*10].pushed?
          $day = i + @page_num*10
          self.next_scene = Pic_serect_Scene
        end
      end
    else
      for i in 0 .. $name_day.size-1-(@page_num*10)
        if @btn_day[i + @page_num*10].pushed?
          $day = i + @page_num*10
          self.next_scene = Pic_serect_Scene
        end
      end
    end
    if @btn_esc.pushed?
      exit
    end
    if @page_num < @page
      if @btn_up.pushed? 
        @page_num += 1
      end
    end
    if @page_num > 0
      if @btn_down.pushed? 
        @page_num -= 1
      end
    end
  end
  
  def render
    if @page > @page_num
      for i in 0.. 9
        @btn_day[i+@page_num*10].render
      end
    else
      for i in 0 .. $name_day.size-1-(@page_num*10)
        @btn_day[i+@page_num*10].render
      end
    end
    @btn_esc.render
    if @page_num > 0 && @page_num < @page && @page != 0
      @btn_up.render
      @btn_down.render
    elsif @page_num < @page && @page != 0
      @btn_up.render
    elsif @page_num == @page && @page != 0
      @btn_down.render
    end
  end
end

class Pic_serect_Scene < Scene::Base
  def init
    @btn_esc = Button.new(Window_w-72, 0, "I", 16,72,36)
    if $back_flag == 0 #ڂI   $day_count_flag == 0 &&
      $day_count_flag = 0
      $count_day=Dir.glob("#{$name_day[$day]}/**")
      @btn_name = Array.new
      for i in 0 .. $count_day.size-1
        @btn_name[i] = $count_day[i].dup
        for j in 0 .. 15#shot/폜
          @btn_name[i].slice!(0)
        end
        
      end
      @page = 0
      @page_num = 0
      @btn_up   = Button.new(Window_w/2+200,Window_h/2 - 25  , "", 16,50,50)
      @btn_down = Button.new(Window_w/2-250,Window_h/2 - 25  , "", 16,50,50)
      @btn_count = Array.new
      for i in 0 .. $count_day.size-1
        @btn_count[i] = Button.new(Window_w/2-72*2,Window_h/2 - 200 + 40*(i%10) , "#{@btn_name[i].to_i+1}", 16,72*4,36)
        @page = i / 10
      end
    else#GI
      @page = $pic_count/20
      @page_num = 0
      @btn_up   = Button.new(Window_w/2+450,Window_h/2+345  , "", 16,50,50)
      @btn_down = Button.new(Window_w/2-450,Window_h/2+345  , "", 16,50,50)
    end
    @btn_back=Button.new(10, Window_h/2+345, "߂",15,50,40)
  end
  
  def update
    if $day_count_flag == 0#ڂI
      if @page > @page_num
        for i in 0 .. 9
          if @btn_count[i + @page_num*10].pushed?
            $day_count = i + @page_num*10
            if $day_count < 10
              $pic_num=Dir.glob("#{$name_day[$day]}/0#{$day_count}/*")
            else
              $pic_num=Dir.glob("#{$name_day[$day]}/#{$day_count}/*")
            end
            $pic_count = 0#G̖
            for j in 0 .. $pic_num.size-1              
              if j <10
                if Dir.glob("#{$pic_num[j]}/*") != []
                  $pic_count += 1
                end
              else
                if Dir.glob("#{$pic_num[j]}/*") != []
                  $pic_count += 1
                end
              end
            end
            $btn_pic = Array.new
            $waku    = Array.new
            for j in 0 .. $pic_count-1#900*700
              $btn_pic[j] = Button.new(22+(j%5)*200,44+((j%20)/5)*181 , "", 16,72*4,36)
              $btn_pic[j].image=("#{$pic_num[j]}/1.png")
              $waku[j] = Button.new(22+(j%5)*200,44+((j%20)/5)*181)
              $waku[j].image=("./lib/waku.png")
            end
            @page = $pic_count/20
            $day_count_flag = 1
            $back_flag = 1
            self.next_scene = Pic_serect_Scene
          end
        end
      else
        for i in 0 .. $count_day.size-1-(@page_num*10)
          if @btn_count[i + @page_num*10].pushed?
            $day_count = i + @page_num*10
            $day_count_flag = 1
            if $day_count < 10
              $pic_num=Dir.glob("#{$name_day[$day]}/0#{$day_count}/*")
            else
              $pic_num=Dir.glob("#{$name_day[$day]}/#{$day_count}/*")
            end
            $pic_count = 0#G̖
            for j in 0 .. $pic_num.size-1
              if j <10
                if Dir.glob("#{$pic_num[j]}/*") != []
                  $pic_count += 1
                end
              else
                if Dir.glob("#{$pic_num[j]}/*") != []
                  $pic_count += 1
                end
              end
            end
            $btn_pic = Array.new
            $waku    = Array.new
            for j in 0 .. $pic_count-1#900*700
              $btn_pic[j] = Button.new(22+(j%5)*200,44+((j%20)/5)*181 , "", 16,72*4,36)
              if j < 10
                $btn_pic[j].image=("#{$pic_num[j]}/1.png")
              else
                $btn_pic[j].image=("#{$pic_num[j]}/1.png")
              end
              $waku[j] = Button.new(22+(j%5)*200,44+((j%20)/5)*181)
              $waku[j].image=("./lib/waku.png")
            end
            @page = $pic_count/20
            $back_flag = 1
            self.next_scene = Pic_serect_Scene
          end
        end
      end
    else#GI
      for i in 0 .. $pic_count-1
        if $waku[i].pushed?
          $serect = i
          self.next_scene = Game_Scene
        end
      end
    end
    if @btn_back.pushed?
      if $day_count_flag == 0
        self.next_scene = Day_serect_Scene
      elsif $day_count_flag == 1
        self.next_scene = Pic_serect_Scene
        $back_flag = 0
      end
    end
    if @btn_esc.pushed?
      exit
    end
    if @page_num < @page
      if @btn_up.pushed? 
        @page_num += 1
      end
    end
    if @page_num > 0
      if @btn_down.pushed? 
        @page_num -= 1
      end
    end
  end
  
  def render
    if $day_count_flag == 0#ڂI
      if @page > @page_num
        for i in 0.. 9
          @btn_count[i+@page_num*10].render
        end
      else
        for i in 0 .. $count_day.size-1-(@page_num*10)
          @btn_count[i+@page_num*10].render
        end
      end
    elsif $day_count_flag == 1
      if @page > @page_num
        for i in 0.. 19
          $waku[i+@page_num*20].render
          $btn_pic[i+@page_num*20].scale_render(0.2,0.2)
        end
      else
        for i in 0 .. $pic_count-1-(@page_num*20)
          $waku[i+@page_num*20].render
          $btn_pic[i+@page_num*20].scale_render(0.2,0.2)
        end
      end
    end
    @btn_back.render
    @btn_esc.render#@page_num > 0 && @page != 0
    if @page_num > 0 && @page_num < @page && @page != 0
      @btn_up.render
      @btn_down.render
    elsif @page_num < @page && @page != 0
      @btn_up.render
    elsif @page_num == @page && @page != 0
      @btn_down.render
    end
  end
  
end 

#$name_day=Dir.glob("shot/*")
#=begin
class Game_Scene < Scene::Base
  def init
    @btn_play =Button.new(10, Window_h/2-100, "͂߂",15,50*2,40)
    @btn_stop =Button.new(10, Window_h/2    , "~",15,50*2,40)
    @btn_start=Button.new(10, Window_h/2    , "ĊJ",15,50*2,40)
    @btn_save =Button.new(10, Window_h/2+100, "ۑ",15,50*2,40)
    @btn_back =Button.new(10, Window_h/2+300, "߂",15,50*2,40)
    @btn_esc = Button.new(Window_w-72, 0, "I", 16,72,36)
    @stroke_count = 0
    @flagCount = 0
    make
    @f_play= :on
    S_Timer.reset
  end
  
  def make
    @canvas_data=[$config[0][0].to_i,$config[0][1].to_i,$config[0][2].to_i,$config[0][3].to_i]
    @img_canvas=Images.new(@canvas_data[0],@canvas_data[1],White,@canvas_data[2],@canvas_data[3])##LoXɕ`
    @log_load = Dir.glob("#{$pic_num[$serect]}/*.csv")
    @csv_ary = load_datafile("#{@log_load[0]}")#f[^
    for i in 0..@csv_ary.size-1
      @csv_ary[i][1] = @csv_ary[i][1].to_i + 100
      @csv_ary[i][2] = @csv_ary[i][2].to_i + 10
    end
    if @csv_ary != []
      @cnt_play_end=@csv_ary[@csv_ary.size-1][0].to_i#Ō̉搔
      @f_kaku=Fonts.new("#{@csv_ary[0][0]}",10,50,36,Black)
    end
    @cnt_play=0
    
    @kaku = 0
  end
  def stroke
    
  end
  
  def play_s
    if @csv_ary[@cnt_play+1]!=nil
      after_x=@csv_ary[@cnt_play+1][1].to_i
      after_y=@csv_ary[@cnt_play+1][2].to_i
      if @csv_ary[@cnt_play][0].to_i==@csv_ary[@cnt_play+1][0].to_i
        if  @csv_ary[@cnt_play][3].to_i != 10
          @img_canvas.circlefill(@csv_ary[@cnt_play][1].to_i-@canvas_data[0],@csv_ary[@cnt_play][2].to_i-@canvas_data[1],@csv_ary[@cnt_play][3].to_i,Black)
          for j in 0..@csv_ary[@cnt_play][3].to_i#҂
            @img_canvas.line(@csv_ary[@cnt_play][1].to_i-@canvas_data[0]+j, @csv_ary[@cnt_play][2].to_i-@canvas_data[1], after_x-@canvas_data[0]+j, after_y-@canvas_data[1], Black)
            @img_canvas.line(@csv_ary[@cnt_play][1].to_i-@canvas_data[0], @csv_ary[@cnt_play][2].to_i-@canvas_data[1]+j, after_x-@canvas_data[0], after_y-@canvas_data[1]+j, Black)
            @img_canvas.line(@csv_ary[@cnt_play][1].to_i-@canvas_data[0]-j, @csv_ary[@cnt_play][2].to_i-@canvas_data[1], after_x-@canvas_data[0]-j, after_y-@canvas_data[1], Black)
            @img_canvas.line(@csv_ary[@cnt_play][1].to_i-@canvas_data[0], @csv_ary[@cnt_play][2].to_i-@canvas_data[1]-j, after_x-@canvas_data[0], after_y-@canvas_data[1]-j, Black)
          end
        else
          @img_canvas.circlefill(@csv_ary[@cnt_play][1].to_i-@canvas_data[0],@csv_ary[@cnt_play][2].to_i-@canvas_data[1],@csv_ary[@cnt_play][3].to_i,White)
          for j in 0..@csv_ary[@cnt_play][3].to_i#
            @img_canvas.line(@csv_ary[@cnt_play][1].to_i-@canvas_data[0]+j, @csv_ary[@cnt_play][2].to_i-@canvas_data[1], after_x-@canvas_data[0]+j, after_y-@canvas_data[1], White)
            @img_canvas.line(@csv_ary[@cnt_play][1].to_i-@canvas_data[0], @csv_ary[@cnt_play][2].to_i-@canvas_data[1]+j, after_x-@canvas_data[0], after_y-@canvas_data[1]+j, White)
            @img_canvas.line(@csv_ary[@cnt_play][1].to_i-@canvas_data[0]-j, @csv_ary[@cnt_play][2].to_i-@canvas_data[1], after_x-@canvas_data[0]-j, after_y-@canvas_data[1], White)
            @img_canvas.line(@csv_ary[@cnt_play][1].to_i-@canvas_data[0], @csv_ary[@cnt_play][2].to_i-@canvas_data[1]-j, after_x-@canvas_data[0], after_y-@canvas_data[1]-j, White)
          end
        end
      else
        if  @csv_ary[@cnt_play][3].to_i != 10#҂
          @img_canvas.circlefill(@csv_ary[@cnt_play][1].to_i-@canvas_data[0],@csv_ary[@cnt_play][2].to_i-@canvas_data[1],@csv_ary[@cnt_play][3].to_i,Black)
        else
          @img_canvas.circlefill(@csv_ary[@cnt_play][1].to_i-@canvas_data[0],@csv_ary[@cnt_play][2].to_i-@canvas_data[1],@csv_ary[@cnt_play][3].to_i,White)
        end
      end
    end
    @cnt_play+=1 if @csv_ary[@cnt_play+1]!=nil
    if  @csv_ary[@cnt_play][3].to_i != 10#҂
      @img_canvas.circlefill(@csv_ary[@cnt_play][1].to_i-@canvas_data[0],@csv_ary[@cnt_play][2].to_i-@canvas_data[1],@csv_ary[@cnt_play][3].to_i,Black)
    else
      @img_canvas.circlefill(@csv_ary[@cnt_play][1].to_i-@canvas_data[0],@csv_ary[@cnt_play][2].to_i-@canvas_data[1],@csv_ary[@cnt_play][3].to_i,White)
    end
  end
  
  def image_save
    name="save/"+"#{Time.now.strftime("%Y_%m_%d_%H_%M_%S")}"+".png"
    @img_canvas.save=("#{name}")
  end
  def kaku
    @f_kaku.string=("#{@csv_ary[@cnt_play][0].to_i}")
  end
  def stopFlag
    if @f_play== :on
      @f_play= :off
    else
      @f_play= :on
    end 
  end
  def update
    if @csv_ary != []
      if @csv_ary[@cnt_play][0].to_i != 
        kaku
      end
      if @f_play== :on
        if @btn_stop.pushed? 
          stopFlag
        end
      else
        if @btn_start.pushed? 
          stopFlag
        end
      end
        play_s if @f_play == :on
      if @btn_save.pushed?
        image_save
      end
      if @btn_play.pushed?
        make
        S_Timer.reset
      end
    end
    if @btn_back.pushed?
      #$day_count_flag = 1
      self.next_scene = Pic_serect_Scene
    end
    if @btn_esc.pushed?
      exit
    end
  end

  def render
    @img_canvas.render
    @btn_play.render
    @btn_stop.render if @f_play== :on
    @btn_start.render if @f_play== :off
    @btn_save.render
    @btn_back.render
    if @csv_ary != []
      @f_kaku.render
    end
    @btn_esc.render
  end
end

class End_Scene < Scene::Base
  def init
    init_btn_make
  end

  def update
    init_btn_update
  end

  def render
    init_btn_render
  end
end
########################################################
########################################################
Scene.main_loop Title_Scene
